from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from Products.SilvaMetadata.Compatibility import registerTypeForMetadata
from Products.Silva import SilvaPermissions
from Products.Silva.helpers import add_and_edit
from Products.Silva.Asset import Asset
from Products.Silva.interfaces import IAsset
from Products.Silva import mangle

icon = "www/silvageneric.gif"

class SilvaBlogViewer(Asset):
    """Silva Blog Viewer"""

    security = ClassSecurityInfo()
    meta_type = 'Silva Blog Viewer'
    __implements__ = (IAsset)

    numitems = 0

    def __init__(self, id, numitems):
        SilvaBlogViewer.inheritedAttribute('__init__')(self, id)
        self.numitems = numitems

    security.declareProtected(SilvaPermissions.AccessContentsInformation,
                                'get_current_items')
    def get_current_items(self):
        """get the current items for this blog"""
        # list of tuples (obj, publication_time)
        objs = []
        for obj in self.objectValues():
            objs.append((obj, obj.get_public_version_publication_datetime()))
        objs.sort(lambda a, b: cmp(a[1], b[1]))

        return objs[:self.numitems]

InitializeClass(SilvaBlogViewer)

def manage_addSilvaBlogViewer(self, id, title, REQUEST=None):
    if not mangle.Id(self, id).isValid():
        return
    o = SilvaBlogViewer(id)
    self._setObject(id, o)
    object = getattr(self, id)
    object.manage_addProduct['SilvaBlog'].manage_addSilvaBlogViewerVersion('0', title)
    object.create_version('0', None, None)
    add_and_edit(self, id, REQUEST)
    return ''

manage_addSilvaBlogViewerForm = PageTemplateFile("www/silvaBlogViewerAdd", 
                                    globals(),
                                    __name__='manage_addSilvaBlogViewerForm')

registerTypeForMetadata(SilvaBlogViewer.meta_type)
